//-----------------------------------------------------------------------------
// mpmc_0_wrapper.v
//-----------------------------------------------------------------------------

`timescale 1 ns/10 ps

`uselib lib=unisims_ver lib=mpmc_ddr_v1_00_c

module mpmc_0_wrapper
  (
    SYS_CLK,
    SYS_CLK90,
    SYS_CLK180,
    SYS_CLK270,
    SYS_RST,
    Arb_sync,
    P0_AddrReq,
    P0_AddrAck,
    P0_Addr,
    P0_RNW,
    P0_Size,
    P0_wrData_Pos,
    P0_wrData_Neg,
    P0_wrDataBE_Pos,
    P0_wrDataBE_Neg,
    P0_wrDataAck_Pos,
    P0_wrDataAck_Neg,
    P0_rdDataRdy,
    P0_rdData_Pos,
    P0_rdData_Neg,
    P0_rdDataAck_Pos,
    P0_rdDataAck_Neg,
    P0_rdWdAddr_Pos,
    P0_rdWdAddr_Neg,
    P0_rdComp,
    P0_wrComp,
    P0_rd_rst,
    P0_wr_rst,
    P0_rd_fifo_busy,
    P0_wr_fifo_busy,
    P0_wr_fifo_full_Pos,
    P0_wr_fifo_full_Neg,
    P1_AddrReq,
    P1_AddrAck,
    P1_Addr,
    P1_RNW,
    P1_Size,
    P1_wrData_Pos,
    P1_wrData_Neg,
    P1_wrDataBE_Pos,
    P1_wrDataBE_Neg,
    P1_wrDataAck_Pos,
    P1_wrDataAck_Neg,
    P1_rdDataRdy,
    P1_rdData_Pos,
    P1_rdData_Neg,
    P1_rdDataAck_Pos,
    P1_rdDataAck_Neg,
    P1_rdWdAddr_Pos,
    P1_rdWdAddr_Neg,
    P1_rdComp,
    P1_wrComp,
    P1_rd_rst,
    P1_wr_rst,
    P1_rd_fifo_busy,
    P1_wr_fifo_busy,
    P1_wr_fifo_full_Pos,
    P1_wr_fifo_full_Neg,
    P2_AddrReq,
    P2_AddrAck,
    P2_Addr,
    P2_RNW,
    P2_Size,
    P2_wrData_Pos,
    P2_wrData_Neg,
    P2_wrDataBE_Pos,
    P2_wrDataBE_Neg,
    P2_wrDataAck_Pos,
    P2_wrDataAck_Neg,
    P2_rdDataRdy,
    P2_rdData_Pos,
    P2_rdData_Neg,
    P2_rdDataAck_Pos,
    P2_rdDataAck_Neg,
    P2_rdWdAddr_Pos,
    P2_rdWdAddr_Neg,
    P2_rdComp,
    P2_wrComp,
    P2_rd_rst,
    P2_wr_rst,
    P2_rd_fifo_busy,
    P2_wr_fifo_busy,
    P2_wr_fifo_full_Pos,
    P2_wr_fifo_full_Neg,
    P3_AddrReq,
    P3_AddrAck,
    P3_Addr,
    P3_RNW,
    P3_Size,
    P3_wrData_Pos,
    P3_wrData_Neg,
    P3_wrDataBE_Pos,
    P3_wrDataBE_Neg,
    P3_wrDataAck_Pos,
    P3_wrDataAck_Neg,
    P3_rdDataRdy,
    P3_rdData_Pos,
    P3_rdData_Neg,
    P3_rdDataAck_Pos,
    P3_rdDataAck_Neg,
    P3_rdWdAddr_Pos,
    P3_rdWdAddr_Neg,
    P3_rdComp,
    P3_wrComp,
    P3_rd_rst,
    P3_wr_rst,
    P3_rd_fifo_busy,
    P3_wr_fifo_busy,
    P3_wr_fifo_full_Pos,
    P3_wr_fifo_full_Neg,
    DDR_A,
    DDR_BA,
    DDR_Cas_O,
    DDR_Cke_O,
    DDR_Cs_O,
    DDR_Ras_O,
    DDR_We_O,
    ddr_dq_I,
    ddr_dq_O,
    ddr_dq_T,
    ddr_be_I,
    ddr_be_O,
    ddr_be_T,
    DDR_Dqs_I,
    DDR_Dqs_O,
    DDR_Dqs_T
  );
  input SYS_CLK;
  input SYS_CLK90;
  input SYS_CLK180;
  input SYS_CLK270;
  input SYS_RST;
  output Arb_sync;
  input P0_AddrReq;
  output P0_AddrAck;
  input [31:0] P0_Addr;
  input P0_RNW;
  input [1:0] P0_Size;
  input [31:0] P0_wrData_Pos;
  input [31:0] P0_wrData_Neg;
  input [3:0] P0_wrDataBE_Pos;
  input [3:0] P0_wrDataBE_Neg;
  input P0_wrDataAck_Pos;
  input P0_wrDataAck_Neg;
  output P0_rdDataRdy;
  output [31:0] P0_rdData_Pos;
  output [31:0] P0_rdData_Neg;
  input P0_rdDataAck_Pos;
  input P0_rdDataAck_Neg;
  output [4:0] P0_rdWdAddr_Pos;
  output [4:0] P0_rdWdAddr_Neg;
  input P0_rdComp;
  input P0_wrComp;
  input P0_rd_rst;
  input P0_wr_rst;
  output P0_rd_fifo_busy;
  output P0_wr_fifo_busy;
  output P0_wr_fifo_full_Pos;
  output P0_wr_fifo_full_Neg;
  input P1_AddrReq;
  output P1_AddrAck;
  input [31:0] P1_Addr;
  input P1_RNW;
  input [1:0] P1_Size;
  input [31:0] P1_wrData_Pos;
  input [31:0] P1_wrData_Neg;
  input [3:0] P1_wrDataBE_Pos;
  input [3:0] P1_wrDataBE_Neg;
  input P1_wrDataAck_Pos;
  input P1_wrDataAck_Neg;
  output P1_rdDataRdy;
  output [31:0] P1_rdData_Pos;
  output [31:0] P1_rdData_Neg;
  input P1_rdDataAck_Pos;
  input P1_rdDataAck_Neg;
  output [4:0] P1_rdWdAddr_Pos;
  output [4:0] P1_rdWdAddr_Neg;
  input P1_rdComp;
  input P1_wrComp;
  input P1_rd_rst;
  input P1_wr_rst;
  output P1_rd_fifo_busy;
  output P1_wr_fifo_busy;
  output P1_wr_fifo_full_Pos;
  output P1_wr_fifo_full_Neg;
  input P2_AddrReq;
  output P2_AddrAck;
  input [31:0] P2_Addr;
  input P2_RNW;
  input [1:0] P2_Size;
  input [31:0] P2_wrData_Pos;
  input [31:0] P2_wrData_Neg;
  input [3:0] P2_wrDataBE_Pos;
  input [3:0] P2_wrDataBE_Neg;
  input P2_wrDataAck_Pos;
  input P2_wrDataAck_Neg;
  output P2_rdDataRdy;
  output [31:0] P2_rdData_Pos;
  output [31:0] P2_rdData_Neg;
  input P2_rdDataAck_Pos;
  input P2_rdDataAck_Neg;
  output [4:0] P2_rdWdAddr_Pos;
  output [4:0] P2_rdWdAddr_Neg;
  input P2_rdComp;
  input P2_wrComp;
  input P2_rd_rst;
  input P2_wr_rst;
  output P2_rd_fifo_busy;
  output P2_wr_fifo_busy;
  output P2_wr_fifo_full_Pos;
  output P2_wr_fifo_full_Neg;
  input P3_AddrReq;
  output P3_AddrAck;
  input [31:0] P3_Addr;
  input P3_RNW;
  input [1:0] P3_Size;
  input [31:0] P3_wrData_Pos;
  input [31:0] P3_wrData_Neg;
  input [3:0] P3_wrDataBE_Pos;
  input [3:0] P3_wrDataBE_Neg;
  input P3_wrDataAck_Pos;
  input P3_wrDataAck_Neg;
  output P3_rdDataRdy;
  output [31:0] P3_rdData_Pos;
  output [31:0] P3_rdData_Neg;
  input P3_rdDataAck_Pos;
  input P3_rdDataAck_Neg;
  output [4:0] P3_rdWdAddr_Pos;
  output [4:0] P3_rdWdAddr_Neg;
  input P3_rdComp;
  input P3_wrComp;
  input P3_rd_rst;
  input P3_wr_rst;
  output P3_rd_fifo_busy;
  output P3_wr_fifo_busy;
  output P3_wr_fifo_full_Pos;
  output P3_wr_fifo_full_Neg;
  output [12:0] DDR_A;
  output [1:0] DDR_BA;
  output DDR_Cas_O;
  output DDR_Cke_O;
  output DDR_Cs_O;
  output DDR_Ras_O;
  output DDR_We_O;
  input [31:0] ddr_dq_I;
  output [31:0] ddr_dq_O;
  output [31:0] ddr_dq_T;
  input [3:0] ddr_be_I;
  output [3:0] ddr_be_O;
  output [3:0] ddr_be_T;
  input [3:0] DDR_Dqs_I;
  output [3:0] DDR_Dqs_O;
  output [3:0] DDR_Dqs_T;

wire [31:0] ddr_dq_I_delayed;

  defparam mpmc_0.C_SET_REG_DIMMS = 0;
  defparam mpmc_0.C_AR_MAX = 'h002e0;
  defparam mpmc_0.C_START_MAX = 'h00400;
  defparam mpmc_0.C_DDR_SIZE = "x16_64MB";
  defparam mpmc_0.C_FAMILY = "virtex4";
  mpmc_ddr
    mpmc_0 (
      .SYS_CLK ( SYS_CLK ),
      .SYS_CLK90 ( SYS_CLK90 ),
      .SYS_CLK180 ( SYS_CLK180 ),
      .SYS_CLK270 ( SYS_CLK270 ),
      .SYS_RST ( SYS_RST ),
      .Arb_sync ( Arb_sync ),
      .P0_AddrReq ( P0_AddrReq ),
      .P0_AddrAck ( P0_AddrAck ),
      .P0_Addr ( P0_Addr ),
      .P0_RNW ( P0_RNW ),
      .P0_Size ( P0_Size ),
      .P0_wrData_Pos ( P0_wrData_Pos ),
      .P0_wrData_Neg ( P0_wrData_Neg ),
      .P0_wrDataBE_Pos ( P0_wrDataBE_Pos ),
      .P0_wrDataBE_Neg ( P0_wrDataBE_Neg ),
      .P0_wrDataAck_Pos ( P0_wrDataAck_Pos ),
      .P0_wrDataAck_Neg ( P0_wrDataAck_Neg ),
      .P0_rdDataRdy ( P0_rdDataRdy ),
      .P0_rdData_Pos ( P0_rdData_Pos ),
      .P0_rdData_Neg ( P0_rdData_Neg ),
      .P0_rdDataAck_Pos ( P0_rdDataAck_Pos ),
      .P0_rdDataAck_Neg ( P0_rdDataAck_Neg ),
      .P0_rdWdAddr_Pos ( P0_rdWdAddr_Pos ),
      .P0_rdWdAddr_Neg ( P0_rdWdAddr_Neg ),
      .P0_rdComp ( P0_rdComp ),
      .P0_wrComp ( P0_wrComp ),
      .P0_rd_rst ( P0_rd_rst ),
      .P0_wr_rst ( P0_wr_rst ),
      .P0_rd_fifo_busy ( P0_rd_fifo_busy ),
      .P0_wr_fifo_busy ( P0_wr_fifo_busy ),
      .P0_wr_fifo_full_Pos ( P0_wr_fifo_full_Pos ),
      .P0_wr_fifo_full_Neg ( P0_wr_fifo_full_Neg ),
      .P1_AddrReq ( P1_AddrReq ),
      .P1_AddrAck ( P1_AddrAck ),
      .P1_Addr ( P1_Addr ),
      .P1_RNW ( P1_RNW ),
      .P1_Size ( P1_Size ),
      .P1_wrData_Pos ( P1_wrData_Pos ),
      .P1_wrData_Neg ( P1_wrData_Neg ),
      .P1_wrDataBE_Pos ( P1_wrDataBE_Pos ),
      .P1_wrDataBE_Neg ( P1_wrDataBE_Neg ),
      .P1_wrDataAck_Pos ( P1_wrDataAck_Pos ),
      .P1_wrDataAck_Neg ( P1_wrDataAck_Neg ),
      .P1_rdDataRdy ( P1_rdDataRdy ),
      .P1_rdData_Pos ( P1_rdData_Pos ),
      .P1_rdData_Neg ( P1_rdData_Neg ),
      .P1_rdDataAck_Pos ( P1_rdDataAck_Pos ),
      .P1_rdDataAck_Neg ( P1_rdDataAck_Neg ),
      .P1_rdWdAddr_Pos ( P1_rdWdAddr_Pos ),
      .P1_rdWdAddr_Neg ( P1_rdWdAddr_Neg ),
      .P1_rdComp ( P1_rdComp ),
      .P1_wrComp ( P1_wrComp ),
      .P1_rd_rst ( P1_rd_rst ),
      .P1_wr_rst ( P1_wr_rst ),
      .P1_rd_fifo_busy ( P1_rd_fifo_busy ),
      .P1_wr_fifo_busy ( P1_wr_fifo_busy ),
      .P1_wr_fifo_full_Pos ( P1_wr_fifo_full_Pos ),
      .P1_wr_fifo_full_Neg ( P1_wr_fifo_full_Neg ),
      .P2_AddrReq ( P2_AddrReq ),
      .P2_AddrAck ( P2_AddrAck ),
      .P2_Addr ( P2_Addr ),
      .P2_RNW ( P2_RNW ),
      .P2_Size ( P2_Size ),
      .P2_wrData_Pos ( P2_wrData_Pos ),
      .P2_wrData_Neg ( P2_wrData_Neg ),
      .P2_wrDataBE_Pos ( P2_wrDataBE_Pos ),
      .P2_wrDataBE_Neg ( P2_wrDataBE_Neg ),
      .P2_wrDataAck_Pos ( P2_wrDataAck_Pos ),
      .P2_wrDataAck_Neg ( P2_wrDataAck_Neg ),
      .P2_rdDataRdy ( P2_rdDataRdy ),
      .P2_rdData_Pos ( P2_rdData_Pos ),
      .P2_rdData_Neg ( P2_rdData_Neg ),
      .P2_rdDataAck_Pos ( P2_rdDataAck_Pos ),
      .P2_rdDataAck_Neg ( P2_rdDataAck_Neg ),
      .P2_rdWdAddr_Pos ( P2_rdWdAddr_Pos ),
      .P2_rdWdAddr_Neg ( P2_rdWdAddr_Neg ),
      .P2_rdComp ( P2_rdComp ),
      .P2_wrComp ( P2_wrComp ),
      .P2_rd_rst ( P2_rd_rst ),
      .P2_wr_rst ( P2_wr_rst ),
      .P2_rd_fifo_busy ( P2_rd_fifo_busy ),
      .P2_wr_fifo_busy ( P2_wr_fifo_busy ),
      .P2_wr_fifo_full_Pos ( P2_wr_fifo_full_Pos ),
      .P2_wr_fifo_full_Neg ( P2_wr_fifo_full_Neg ),
      .P3_AddrReq ( P3_AddrReq ),
      .P3_AddrAck ( P3_AddrAck ),
      .P3_Addr ( P3_Addr ),
      .P3_RNW ( P3_RNW ),
      .P3_Size ( P3_Size ),
      .P3_wrData_Pos ( P3_wrData_Pos ),
      .P3_wrData_Neg ( P3_wrData_Neg ),
      .P3_wrDataBE_Pos ( P3_wrDataBE_Pos ),
      .P3_wrDataBE_Neg ( P3_wrDataBE_Neg ),
      .P3_wrDataAck_Pos ( P3_wrDataAck_Pos ),
      .P3_wrDataAck_Neg ( P3_wrDataAck_Neg ),
      .P3_rdDataRdy ( P3_rdDataRdy ),
      .P3_rdData_Pos ( P3_rdData_Pos ),
      .P3_rdData_Neg ( P3_rdData_Neg ),
      .P3_rdDataAck_Pos ( P3_rdDataAck_Pos ),
      .P3_rdDataAck_Neg ( P3_rdDataAck_Neg ),
      .P3_rdWdAddr_Pos ( P3_rdWdAddr_Pos ),
      .P3_rdWdAddr_Neg ( P3_rdWdAddr_Neg ),
      .P3_rdComp ( P3_rdComp ),
      .P3_wrComp ( P3_wrComp ),
      .P3_rd_rst ( P3_rd_rst ),
      .P3_wr_rst ( P3_wr_rst ),
      .P3_rd_fifo_busy ( P3_rd_fifo_busy ),
      .P3_wr_fifo_busy ( P3_wr_fifo_busy ),
      .P3_wr_fifo_full_Pos ( P3_wr_fifo_full_Pos ),
      .P3_wr_fifo_full_Neg ( P3_wr_fifo_full_Neg ),
      .DDR_A ( DDR_A ),
      .DDR_BA ( DDR_BA ),
      .DDR_Cas_O ( DDR_Cas_O ),
      .DDR_Cke_O ( DDR_Cke_O ),
      .DDR_Cs_O ( DDR_Cs_O ),
      .DDR_Ras_O ( DDR_Ras_O ),
      .DDR_We_O ( DDR_We_O ),
      .ddr_dq_I ( ddr_dq_I_delayed ),
      .ddr_dq_O ( ddr_dq_O ),
      .ddr_dq_T ( ddr_dq_T ),
      .ddr_be_I ( ddr_be_I ),
      .ddr_be_O ( ddr_be_O ),
      .ddr_be_T ( ddr_be_T ),
      .DDR_Dqs_I ( DDR_Dqs_I ),
      .DDR_Dqs_O ( DDR_Dqs_O ),
      .DDR_Dqs_T ( DDR_Dqs_T )
    );
//board delay adder
assign #0.3 ddr_dq_I_delayed =  ddr_dq_I;

endmodule

