//-----------------------------------------------------------------------------
// system.v
//-----------------------------------------------------------------------------

`timescale 1 ns/10 ps

module tb();

  wire REFCLK;
  wire SYS_RST_N;
  wire usb_cs_n;
  wire sysace_mpce;
  wire SYSACE_CLK;
  wire Uart1_sin;
  wire Uart1_sout;
  wire [12:0] DDR_ad;
  wire [1:0] DDR_ba;
  wire DDR_casb;
  wire DDR_cke;
  wire DDR_csb;
  wire [31:0] DDR_dq;
  wire [3:0] DDR_dm;
  wire [3:0] DDR_dqs;
  wire DDR_rasb;
  wire DDR_web;
  wire DDR_clk;
  wire DDR_clkb;
  wire RAID_start; 
  wire RAID_done;         
system system
  (
    .REFCLK      (REFCLK),
    .SYS_RST_N   (SYS_RST_N),
    .usb_cs_n    (usb_cs_n),
    .sysace_mpce (sysace_mpce),
    .SYSACE_CLK  (SYSACE_CLK),
    .Uart1_sin   (Uart1_sin),
    .Uart1_sout  (Uart1_sout),
    .DDR_ad      (DDR_ad),
    .DDR_ba      (DDR_ba),
    .DDR_casb    (DDR_casb),
    .DDR_cke     (DDR_cke),
    .DDR_csb     (DDR_csb),
    .DDR_dq      (DDR_dq),
    .DDR_dm      (DDR_dm),
    .DDR_dqs     (DDR_dqs),
    .DDR_rasb    (DDR_rasb),
    .DDR_web     (DDR_web),
    .DDR_clk     (DDR_clk),
    .DDR_clkb    (DDR_clkb),
    .RAID_start  (RAID_start),
    .RAID_done   (RAID_done)
);


ddr ddra(
   .Dq    (DDR_dq[31:16]), 
   .Dqs   (DDR_dqs[3:2]), 
   .Addr  (DDR_ad), 
   .Ba    (DDR_ba), 
   .Clk   (DDR_clk), 
   .Clk_n (DDR_clkb), 
   .Cke   (DDR_cke), 
   .Cs_n  (DDR_csb), 
   .Ras_n (DDR_rasb), 
   .Cas_n (DDR_casb), 
   .We_n  (DDR_web), 
   .Dm    (DDR_dm[3:2]));

ddr ddrb(
   .Dq    (DDR_dq[15:0]), 
   .Dqs   (DDR_dqs[1:0]), 
   .Addr  (DDR_ad), 
   .Ba    (DDR_ba), 
   .Clk   (DDR_clk), 
   .Clk_n (DDR_clkb), 
   .Cke   (DDR_cke), 
   .Cs_n  (DDR_csb), 
   .Ras_n (DDR_rasb), 
   .Cas_n (DDR_casb), 
   .We_n  (DDR_web), 
   .Dm    (DDR_dm[1:0]));



  

endmodule

