//---------------------------------------------------------------------------*/
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/

#include "stdio.h"
#include <string.h>
#include <stdlib.h>


// usage:
//       ddr_mpmc_load(0x100000,0x000001);
//       ddr_mpmc_read(0x100000);
//       ddr_mpmc_clear(0x100000);





/*********************************************************************
*
* FUNCTION : ddr_mpmc_load
*
*********************************************************************/
void ddr_mpmc_load(
			  unsigned long startAdr,
			  unsigned long start_value)
{
  unsigned long myAdr;
  unsigned long size = 256;
  unsigned long writeAdr;
  unsigned long data2store = start_value;
  int           i=0, j=0, t=0, h=0;
  unsigned long ba, row, col;
  
  
  
  // ---------------------------------------
  //  Write data
  // ---------------------------------------
   
  for(myAdr = startAdr; myAdr < startAdr+size; myAdr=myAdr+4)
    {
      h++;
      //data2store++;
	  data2store = data2store + 0x01010101;
      * (volatile unsigned long *) myAdr = data2store; 
	  
    }
 
 // return();
}
/*********************************************************************
*
* FUNCTION : ddr_mpmc_read
*
*********************************************************************/
 unsigned long ddr_mpmc_read(
			  unsigned long startAdr)
{
  unsigned long myAdr = startAdr;
  unsigned long size = 256;
  int           i=0, j=0, t=0, h=0;
  unsigned long ba, row, col;
  unsigned long dataRead[32];
  
  
  // ---------------------------------------
  //  Read data
  // ---------------------------------------

   dataRead[0] = *(volatile unsigned long *) myAdr;
      
      
    
    return(dataRead[0]);
	
}
/*********************************************************************
*
* FUNCTION : ddr_mpmc_clear
*
*********************************************************************/
 void ddr_mpmc_clear(
			  unsigned long startAdr)
{
  unsigned long myAdr = startAdr;
  unsigned long size = 128;
  unsigned long writeAdr;
  int           i=0, j=0, t=0, h=0;
  unsigned long ba, row, col;
 
  
  
  // ---------------------------------------
  //  Clear data
  // ---------------------------------------
    
for(myAdr = startAdr; myAdr < startAdr+size; myAdr=myAdr+4)
    {
      h++;
      * (volatile unsigned long *) myAdr = 0x00000000; 
    }

}
