//---------------------------------------------------------------------------*/
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/
#include <xpseudo_asm.h>
#include "xexception_l.h"
#include "xbasic_types.h"
#include "xintc.h"
#include "sleep.h"

#include "raid_sim.h"



int request_reconstruct_p(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000001);//need to find P only
//indicate what is lost
mtdcr(RAID_LOST, 0x00000002);// P is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_q(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010000);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020000);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030000);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040000); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050000);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060000);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000002);//need to find P only
//indicate what is lost
//mtdcr(RAID_LOST, 0x00000002);// P is lost
mtdcr(RAID_LOST, 0x00000001);// Q is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d0(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000000);//need to find P only
//indicate what is lost
//mtdcr(RAID_LOST, 0x00000002);// P is lost
mtdcr(RAID_LOST, 0x00000004);// D0 is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d1(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000000);//need to find P only
//indicate what is lost
//mtdcr(RAID_LOST, 0x00000002);// P is lost
mtdcr(RAID_LOST, 0x00000008);// D1 is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d2(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000000);//need t
//indicate what is lost
//mtdcr(RAID_LOST, 0x00000002);// 
mtdcr(RAID_LOST, 0x00000010);// D2 is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}
int request_reconstruct_p_q(void) {
//setting up the DCR registers for the RAID system
//for regenerating P and Q


//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000007);//find P&Q
//indicate what is lost
mtdcr(RAID_LOST, 0x00000003);// P and Q is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}
int request_reconstruct_d0_q(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000006);//find D&Q
//indicate what is lost
mtdcr(RAID_LOST, 0x00000005);// D0 and Q is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d1_q(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000006);//find D&Q
//indicate what is lost
mtdcr(RAID_LOST, 0x00000009);// D1 and Q is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}
int request_reconstruct_d2_q(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000006);//find D&Q
//indicate what is lost
mtdcr(RAID_LOST, 0x00000011);// D2 and Q is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d0_p(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000005);//find D&P
//indicate what is lost
mtdcr(RAID_LOST, 0x00000006);// D0 and P is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d1_p(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000005);//find D&P
//indicate what is lost
mtdcr(RAID_LOST, 0x0000000A);// D1 and P is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}
int request_reconstruct_d2_p(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000005);//find D&P
//indicate what is lost
mtdcr(RAID_LOST, 0x00000012);// D2 and P is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d0_d1(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000004);//find D&D
//indicate what is lost
mtdcr(RAID_LOST, 0x0000000C);// D0 and D1 is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d1_d2(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000004);//find D&D
//indicate what is lost
mtdcr(RAID_LOST, 0x00000018);// D2 and D1 is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_reconstruct_d2_d0(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for DATA3 data
mtdcr(RAID_3, 0x00030001);
//set up address for DATA4 data
mtdcr(RAID_4, 0x00040001); 
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000004);//find D&D
//indicate what is lost
mtdcr(RAID_LOST, 0x00000014);// D0 and D2 is lost
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}



int request_update_pq_d0(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for old DATA0 data
mtdcr(RAID_1, 0x00010001);
//set up address for new DATA0 data
mtdcr(RAID_2, 0x00020001);
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000003);//update P&Q
//indicate what is lost
mtdcr(RAID_LOST, 0x00000004);// D0 will need to be written
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_update_pq_d1(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for old DATA1 data
mtdcr(RAID_1, 0x00010001);
//set up address for new DATA1 data
mtdcr(RAID_2, 0x00020001);
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000003);//update P&Q
//indicate what is lost
mtdcr(RAID_LOST, 0x00000008);// D1 will need to be written
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

int request_update_pq_d2(void) {
//this will eventually have parameters that will be passed in
 

//setting up the DCR registers for the RAID system
//this will become a su

//set up address for old DATA2 data
mtdcr(RAID_1, 0x00010001);
//set up address for new DATA2 data
mtdcr(RAID_2, 0x00020001);
//set up address for Parity data
mtdcr(RAID_P, 0x00050001);
//set up address for Q parity data
mtdcr(RAID_Q, 0x00060001);
//indicate which mode(which disks are missing)
mtdcr(RAID_M, 0x00000003);//update P&Q
//indicate what is lost
mtdcr(RAID_LOST, 0x00000010);// D2 will need to be written
//indicate that a reconstruction is needed
mtdcr(RAID_RECON, 0x00000001);


return 0;


}

