//---------------------------------------------------------------------------*/
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/
#include <xpseudo_asm.h>
#include "xparameters.h"
#include "raid_sim.h"

int main(void) {

  int tmp;

  unsigned long data_start1 = 0x00000100;
  unsigned long data_start2 = 0x00020001;
  unsigned long data_start3 = 0x03000002;
  unsigned long addr_start1 = 0x00010000;
  unsigned long addr_start2 = 0x00020000;
  unsigned long addr_start3 = 0x00030000;
  unsigned long i;
  unsigned long y = addr_start1;
  unsigned long j;

  unsigned long checkdata;
  unsigned long writtendata = data_start1 + 0x01010101;
  

  usleep(1);
  //load first data block
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
 
 


  //load second data block
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
 
  

  //load third data block
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  
  

  
  mtdcr(RAID_SIZE, 0x80000001);//512 block

  mtdcr(RAID_LED, 0x00000001);

  usleep(11);
 
  request_reconstruct_p();

  usleep(10);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_q();
  }
  usleep(11);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0();
  }
  usleep(10);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1();
  }
  usleep(11);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2();
  }
   usleep(11);
    
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_p_q();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_q();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_q();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_q();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_p();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_p();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_p();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_d1();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_d2();
  }
  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_d0();
  }

  usleep(10);
 
  for(i = y;  i < y + 128; i=i+4 )
  {
    checkdata = ddr_mpmc_read(i);
    if(checkdata == writtendata)
    {
       mtdcr(RAID_LED, 0x00000003);
    }
    else
    {
	  tmp = mfdcr(RAID_LED);
      if(tmp == 0x0000003 || tmp == 0x00000007){
	    mtdcr(RAID_LED, 0x00000007);
	  }
	  else{ 
	    mtdcr(RAID_LED, 0x00000004);
	  }
    }
	writtendata = writtendata + 0x01010101; 
  }
    tmp = mfdcr(RAID_LED);
    if(tmp == 0x00000003){
       mtdcr(RAID_LED, 0x0000000B);
	}
	else if(tmp == 0x00000007){
      mtdcr(RAID_LED, 0x0000000F);
	}
	else{
      mtdcr(RAID_LED, 0x0000000D);
	}

   usleep(8);
   data_start1 = 0x03020101;
   data_start2 = 0x04030202;
   addr_start1 = 0x00010000;
   addr_start2 = 0x00020000;
 
  
  writtendata = data_start1 + 0x01010101;
  

  usleep(7);
  //load first data block
  //ddr_mpmc_load(0x00010000,data_start1);
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  //ddr_mpmc_load(addr_start1,data_start1);
 


  //load second data block
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  //ddr_mpmc_load(addr_start2,data_start2);
  


tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d0();
  }
 usleep(16); 
tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d1();
  }
 usleep(16); 
tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d2();
  }
usleep(2);
 
}
