//---------------------------------------------------------------------------*/
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2004 Xilinx, Inc.
//     All rights reserved.
//
//---------------------------------------------------------------------------*/
#include "xuartlite_l.h"
#include "xexception_l.h"
#include "xbasic_types.h"
#include "xintc.h"
#include "sleep.h"


#include <xpseudo_asm.h>
#include "xparameters.h"
#include "uart_test.h"

//uart functions stuff

  // data buffers
  
  Xuint8 buf_pio[BUF_PIO_SIZE];



int main(void) {


Xuint32 b;  // loop invariants


  int tmp;

  unsigned long data_start1 = 0x00000100;
  unsigned long data_start2 = 0x00020001;
  unsigned long data_start3 = 0x03000002;
  unsigned long addr_start1 = 0x00010000;
  unsigned long addr_start2 = 0x00020000;
  unsigned long addr_start3 = 0x00030000;

  unsigned long addr_start4 = 0x00040000;
  unsigned long addr_start5 = 0x00050000;
  unsigned long addr_start6 = 0x00060000;
  unsigned long i;
  unsigned long y = addr_start1;
  unsigned long j;
  unsigned long z;
  unsigned long p;

  unsigned long checkdata;
  unsigned long confirmdata;
  unsigned long writtendata = data_start1 + 0x01010101;
 // clear screen and reset cursor
 
  xil_printf("\n\n\n\n\n\n\n\n\n\n");
  xil_printf("\n\n\n\n\n\n\n\n\n\n");
  xil_printf("\n\n\n\n\n\n\n\n\n\n");
  usleep(1);

  xil_printf("\n\rloading the memory with data\r");
  xil_printf("\n.\n");

  //load first data block
  //ddr_mpmc_load(0x00010000,data_start1);
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
 
  xil_printf("\n..\n");

  //load second data block
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  
  xil_printf("\n...\n");
  //load third data block
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;

 
  for(p = y;  p < y + 512; p=p+4 )
  {
    confirmdata = ddr_mpmc_read(p); 

  }

  
  mtdcr(RAID_SIZE, 0x80000001);//512 block

  mtdcr(RAID_LED, 0x00000001);

  usleep(11);
 
  request_reconstruct_p();

  xil_printf("\n\rReconstruct the P parity...\r");

  usleep(10);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_q();
  }

  xil_printf("\n\rReconstruct the Q parity...\r");
  usleep(11);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0();
  }
  xil_printf("\n\rReconstruct the Data1 ...\r");
  usleep(10);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1();
  }
  xil_printf("\n\rReconstruct the Data2... ...\r");
  usleep(11);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2();
  }
  xil_printf("\n\rReconstruct the Data3... ... ...\r");
   
  usleep(11);
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_p_q();
  }
  xil_printf("\n\rReconstruct the P and Q parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_q();
  }
  xil_printf("\n\rReconstruct the Data1 and Q parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_q();
  }
  xil_printf("\n\rReconstruct the Data2 and Q parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_q();
  }
  xil_printf("\n\rReconstruct the Data3 and Q parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_p();
  }
  xil_printf("\n\rReconstruct the Data1 and P parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_p();
  }
  xil_printf("\n\rReconstruct the Data2 and P parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_p();
  }
  xil_printf("\n\rReconstruct the Data3 and P parity\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d0_d1();
  }
  xil_printf("\n\rReconstruct the Double data 1 & 2\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d1_d2();
  }
  xil_printf("\n\rReconstruct the Double data 2 & 3\r");

  usleep(15);  
  tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_reconstruct_d2_d0();
  }
  xil_printf("\n\rReconstruct the Double data 3 & 1\r");

  usleep(10);
  z = 0;
  xil_printf("\n\r##############################################\r");
  xil_printf("\n\r#Reconstruction is complete now checking data#\r");
  xil_printf("\n\r##############################################\r");
  for(i = y;  i < y + 512; i=i+4 )
  {
    checkdata = ddr_mpmc_read(i);
    if(checkdata == writtendata)
    {
       mtdcr(RAID_LED, 0x00000003);
    }
    else
    {
	  z= z+1;
      xil_printf("\n\rread data is ......\r");
      xil_printf("\n0x%08X\n",checkdata);
      xil_printf("\n\rdata should be ......\r");
      xil_printf("\n0x%08X\n",writtendata);
	  usleep(100000);
	  tmp = mfdcr(RAID_LED);
      if(tmp == 0x0000003 || tmp == 0x00000007){
	    mtdcr(RAID_LED, 0x00000007);
	  }
	  else{ 
	    mtdcr(RAID_LED, 0x00000004);
	  }
    }
	writtendata = writtendata + 0x01010101; 
  }
    tmp = mfdcr(RAID_LED);
    if(tmp == 0x00000003){
       mtdcr(RAID_LED, 0x0000000B);
	   xil_printf("\n\rData test complete:  no errors !\r");
	}
	else if(tmp == 0x00000007){
      mtdcr(RAID_LED, 0x0000000F);
	  xil_printf("\n\rData test complete:  some errors !\r");
	  xil_printf("\n\rnumber of errors is\r");
      xil_printf("\n0h%08X\n", z);
	}
	else{
      mtdcr(RAID_LED, 0x0000000D);
	  xil_printf("\n\rData test complete:  no good data !\r");
	  xil_printf("\n\rnumber of errors is\r");
      xil_printf("\n0h%08X\n", z);
	}

   usleep(8);
   data_start1 = 0x03020100;
   data_start2 = 0x04030201;
   addr_start1 = 0x00010000;
   addr_start2 = 0x00020000;
 
  
  writtendata = data_start1 + 0x01010101;
  xil_printf("\n\rUpdate data, P parity and Q parity....!\r");

  usleep(7);
  //load first data block
  //ddr_mpmc_load(0x00010000,data_start1);
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
 
  //load second data block
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  
tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d0();
  }
 usleep(16); 
tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d1();
  }
 usleep(16); 
tmp = mfdcr( RAID_RECON);
  if(tmp == 0x00000000){
   request_update_pq_d2();
  }
usleep(15);
  xil_printf("\n\rSoftware test is complete have a nice day !!!!!\r");
  xil_printf("\n\n\n\n\n\n\n\n\n\n");

  data_start1 = 0x00000000;
  data_start2 = 0x04030201;
  data_start3 = 0x05040302;
  addr_start1 = 0x00010000;
  addr_start2 = 0x00020000;
  addr_start3 = 0x00030000;
  addr_start4 = 0x00040000;
  addr_start5 = 0x00050000;
  addr_start6 = 0x00060000;

init_mem();

print_message();
  
  
while(TRUE) {

for(b = 0; b < 512; b++) buf_pio[b] = 0;


get_command(buf_pio);

  // choose command
    switch(buf_pio[0]) {
      case '0': xil_printf("\nregen p and q parity\r");  
	            request_reconstruct_p_q();
	            tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case '1': ddr_mpmc_clear(addr_start1);
				break;
      case '2': ddr_mpmc_clear(addr_start2);
				break;
      case '3': ddr_mpmc_clear(addr_start3);
				break;
      case '4': ddr_mpmc_clear(addr_start5);
				break;
      case '5': ddr_mpmc_clear(addr_start6);
	            break;
      case '6': ddr_mpmc_clear(addr_start1);
                ddr_mpmc_clear(addr_start2);
                ddr_mpmc_clear(addr_start3);
                ddr_mpmc_clear(addr_start5);
                ddr_mpmc_clear(addr_start6);
	            xil_printf("\ncleared all blocks\n\r");
	            break;
      case '7': user_write(addr_start1, buf_pio[1]);
	            break;
	  case '8': user_write(addr_start2, buf_pio[1]);
	            break;
      case '9': user_write(addr_start3, buf_pio[1]);
	            break;
      case 'a': read_block(addr_start1);
	            break;
	  case 'b': read_block(addr_start2);
				break;
      case 'c': read_block(addr_start3);
				break;
      case 'd': read_block(addr_start5);
				break;
      case 'e': read_block(addr_start6);
	            break;
      case 'f': init_mem();
	            break;
      case 'g': xil_printf("\ncalling check\n\r");
	            break;
      case 'h': xil_printf("\ngenerating Pparity\n\r");
	            request_reconstruct_p();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
                usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rgeneration complete\n\r");
	            break;
      case 'i': xil_printf("\ngenerating Qparity\n\r");
	            request_reconstruct_q();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rgeneration complete\n\r");
	            break;
      case 'j': print_message();
	            break;
      case 'k': xil_printf("\nregenerating Data block 1\n\r");
	            request_reconstruct_d0();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'l': xil_printf("\nregenerating Data block 2\n\r");
	            request_reconstruct_d1();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'm': xil_printf("\nregenerating Data block 3\n\r");
	            request_reconstruct_d2();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'n': //xil_printf("\nregenerating Data block 1n\r");
	            pattern_write(addr_start1, 0x00000000);
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\r complete\n\r");
	            break;
      case 'o': //xil_printf("\nregenerating Data block 2n\r");
	            pattern_write(addr_start2, 0x01000001);
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\r complete\n\r");
	            break;
      case 'p': //xil_printf("\nregenerating Data block 3n\r");
	            pattern_write(addr_start3, 0x02000002);
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\r complete\n\r");
	            break;
      case 'q': xil_printf("\nregenerating Data block 1 and 2\n\r");
	            request_reconstruct_d0_d1();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'r': xil_printf("\nregenerating Data block 2 and 3\n\r");
	            request_reconstruct_d1_d2();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 's': xil_printf("\nregenerating Data block 3 and 1\n\r");
	            request_reconstruct_d2_d0();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 't': xil_printf("\nregenerating Data block 1 and P\n\r");
	            request_reconstruct_d0_p();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'u': xil_printf("\nregenerating Data block 2 and P\n\r");
	            request_reconstruct_d1_p();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'v': xil_printf("\nregenerating Data block 3 and P\n\r");
	            request_reconstruct_d2_p();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'w': xil_printf("\nregenerating Data block 1 and Q\n\r");
	            request_reconstruct_d0_q();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'x': xil_printf("\nregenerating Data block 2 and Q\n\r");
	            request_reconstruct_d1_q();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'y': xil_printf("\nregenerating Data block 3 and Q\n\r");
	            request_reconstruct_d2_q();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rregeneration complete\n\r");
	            break;
      case 'z': xil_printf("\nupdating P and Q for new data1\n\r");
	            xil_printf("\nyou must have put new data in data2\n\r");
				xil_printf("\nto replace data for old data in data1\n\r");
	            request_update_pq_d0();
				tmp = mfdcr( RAID_RECON);
				while(tmp != 0x000000000){
				usleep(10000);
				tmp = mfdcr( RAID_RECON);
                }
                xil_printf("\n\rupdating complete\n\r");  
	            break;

      default:  break;
   }  
//usleep(10);
}
   


}


/////////////////////////////////////////////////////////////
//below are functions for the uart
/////////////////////////////////////////////////////////////

void get_command(Xuint8 *buf) {

  Xuint8 i = 0, j = 0;
  Xuint8 c;
  Xuint8 tmp[10];
  Xuint8 args = 0;
  Xuint8 a0, a1, a2, a3;
  Xuint8 h, t, o;

 

  //while newline or '\r'
  while((c = inbyte(0)) != '\r') {

    if((c == 0x08) && (i > 0)) {  // backspace and not at buffer start
      outbyte(0x08);
      outbyte(' ');
      outbyte(0x08);
      i--;

    }

    else if((c >= 32) && (c <= 126) && (i < 12)) {  // normal char & not buf end
         outbyte(c);
      buf[i++] = c;

    }

  }

  // terminate string
  buf[i] = 0;


  // move to next non-space character
  for(i = 0; (i < 12) && (buf[i] == ' '); i++);
   

  // copy data into temporary buffer
  for(j = 0; (i < 12) && (buf[i] != ' '); i++, j++)
    tmp[j] = buf[i];

  // move to next non-space character
  for(i = i; (i < 12) && (buf[i] == ' '); i++);

  // copy data into temporary buffer
  for(i = i, j = j; (i < 12) && (buf[i] != ' '); i++, j++) {

    tmp[j] = buf[i];
    // do we have arguments?
    if((buf[i] >= 32) && (buf[i] <= 126))
      args = 1;

  }

  // copy data into temporary buffer
  for(i = i, j = j; j < 10; i++, j++)
    tmp[j] = buf[i];

  // copy command selection parameter and arguments into input buffer
  if((tmp[0] == 'c') && (tmp[1] == 'l') &&(tmp[2] == 'r')) {
    if(tmp[3] == '1') {
    //xil_printf("\nclearing data 1\r");
    buf[0] = '1';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == '2') {
    //xil_printf("\nclearing data 2\r");
    buf[0] = '2';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == '3') {
    //xil_printf("\nclearing data 3\r");
	buf[0] = '3';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == 'p') {
    //xil_printf("\nclearing P parity\r");
    buf[0] = '4';
    buf[1] = 0;
    return; 
	}
    else if(tmp[3] == 'q') {
    //xil_printf("\nclearing Q parity\r");
    buf[0] = '5';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == 'a') {
	//xil_printf("\nclearing all blocks\r");
    buf[0] = '6';
    buf[1] = 0;
    return; 
	}
	else {
xil_printf("\ninvalid clear command\r");
xil_printf("\nvalid commands are clr1 clr2 clr3 clrp clrq or clra \r"); 
    buf[0] = 'j';
    buf[1] = 0;
    return;  
	}
  }
  else if((tmp[0] == 'w') && (tmp[1] == 'r') ) {
    if(tmp[2] == '1') {
	  if(tmp[3] == 'x') {
        //xil_printf("\nwriting data 1\r");
        buf[0] = '7';
       if((tmp[4] == '0') || (tmp[4] == '5') || (tmp[4] == 'A') || (tmp[4] == 'F') || (tmp[4] == 'a') || (tmp[4] == 'f')){
          buf[1] = tmp[4];
		}
        else {	
          buf[0] = 0;
          xil_printf("\n\rUsage: wr1x[ 0 | 5 | a  | f ]\n\r");
        }
        return; 
	  }
	  else {
        buf[0] = 'j';
        xil_printf("\ninvalid write command format\r");
        xil_printf("\nvalid commands include wr1x[ 0 | 5 | a  | f ] \r"); 
		buf[1] = 0;
        return; 
	  } 
	}
	else if(tmp[2] == '2') {
    if(tmp[3] == 'x') {
        //xil_printf("\nwriting data 2\r");
          buf[0] = '8';
        if((tmp[4] == '0') || (tmp[4] == '5') || (tmp[4] == 'A') || (tmp[4] == 'F') || (tmp[4] == 'a') || (tmp[4] == 'f')){
          buf[1] = tmp[4];
		}
        else {	
          buf[0] = 0;
          xil_printf("\n\rUsage: wr2x[ 0 | 5 | a  | f ]\n\r");
        }
        return; 
	  }
	  else {
        buf[0] = 'j';
        xil_printf("\ninvalid write command format\r");
        xil_printf("\nvalid commands include wr2x[ 0 | 5 | a  | f ] \r"); 
		buf[1] = 0;
        return; 
	  } 
	}
	else if(tmp[2] == '3') {
     if(tmp[3] == 'x') {
        //xil_printf("\nwriting data 3\r");
        buf[0] = '9';
       if((tmp[4] == '0') || (tmp[4] == '5') || (tmp[4] == 'A') || (tmp[4] == 'F') || (tmp[4] == 'a') || (tmp[4] == 'f')){
          buf[1] = tmp[4];
		}
        else {	
          buf[0] = 0;
          xil_printf("\n\rUsage: wr3x[ 0 | 5 | a  | f ]\n\r");
        }
        return; 
	  }
	  else {
        buf[0] = 'j';
        xil_printf("\ninvalid write command format\r");
        xil_printf("\nvalid commands include wr3x[ 0 | 5 | a  | f ] \r"); 
		buf[1] = 0;
        return; 
	  } 
	}
  }
  else if((tmp[0] == 'r') && (tmp[1] == 'd') ) {
    if(tmp[2] == '1') {
    xil_printf("\nreading data 1\r");
    buf[0] = 'a';
    buf[1] = 0;
    return; 
	}
	else if(tmp[2] == '2') {
    xil_printf("\nreading data 2\r");
    buf[0] = 'b';
    buf[1] = 0;
    return; 
	}
	else if(tmp[2] == '3') {
    xil_printf("\nreading data 3\r");
	buf[0] = 'c';
    buf[1] = 0;
    return; 
	}
	else if(tmp[2] == 'p') {
    xil_printf("\nreading P parity\r");
    buf[0] = 'd';
    buf[1] = 0;
    return; 
	}
    else if(tmp[2] == 'q') {
    xil_printf("\nreading Q parity\r");
    buf[0] = 'e';
    buf[1] = 0;
    return; 
	}
	else {
    xil_printf("\ninvalid read command\r");
    xil_printf("\nvalid commands are rd1 rd2 rd3 rdp rdq \r"); 
    buf[0] = 'j';
    buf[1] = 0;
    return;  
	}
  }
  else if((tmp[0] == 'i') && (tmp[1] == 'n') && (tmp[2] == 'i') && (tmp[3] == 't')) {
    //xil_printf("\ninitializing data \r");
    buf[0] = 'f';
    buf[1] = 0;
    return; 
	}
  else if((tmp[0] == 'c') && (tmp[1] == 'h') && (tmp[2] == 'e') && (tmp[3] == 'c') && (tmp[4] == 'k')) {
    xil_printf("\nchecking data \r");
    buf[0] = 'g';
    buf[1] = 0;
    return; 
	}
  else if((tmp[0] == 'g') && (tmp[1] == 'e') && (tmp[2] == 'n')) {
    //xil_printf("\ninitializing data \r");
	if(tmp[3] == 'p'){
          buf[0] = 'h';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == 'q'){
    buf[0] = 'i';
    buf[1] = 0;
    return; 
	}
	else {
      xil_printf("\n\rUnrecognized generate command\n\r");
	  xil_printf("\n\rUsage:  genq or genp\n\r");
	}

	}
  else if((tmp[0] == 'l') && (tmp[1] == 's')) {
    buf[0] = 'j';
    buf[1] = 0;
    return; 
	}
  else if((tmp[0] == 'r') && (tmp[1] == 'e') && (tmp[2] == 'g')&& (tmp[3] == 'e') && (tmp[4] == 'n')) {
    if(tmp[5] == '1') {
    xil_printf("\n 1\r");
    buf[0] = 'k';
    buf[1] = 0;
    return; 
	}
	else if(tmp[5] == '2') {
    xil_printf("\n 2\r");
    buf[0] = 'l';
    buf[1] = 0;
    return; 
	}
	else if(tmp[5] == '3') {
    xil_printf("\n 3\r");
	buf[0] = 'm';
    buf[1] = 0;
    return; 
	}
	else {
xil_printf("\ninvalid regenerate command\r");
xil_printf("\nvalid commands are regen1, regen2, regen3 \r"); 
    buf[0] = 'j';
    buf[1] = 0;
    return;  
	}
  }
  else if((tmp[0] == 'c') && (tmp[1] == 'd') && (tmp[2] == 'p')) {
    if(tmp[3] == '1') {
    xil_printf("\n 1\r");
    buf[0] = 'n';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == '2') {
    xil_printf("\n 2\r");
    buf[0] = 'o';
    buf[1] = 0;
    return; 
	}
	else if(tmp[3] == '3') {
    xil_printf("\n 3\r");
	buf[0] = 'p';
    buf[1] = 0;
    return; 
	}
	else {
xil_printf("\ninvalid regenerate command\r");
xil_printf("\nvalid commands are regen1, regen2, regen3 \r"); 
    buf[0] = 'j';
    buf[1] = 0;
    return;  
	}
  }
  else if((tmp[0] == '2') && (tmp[1] == 'r') && (tmp[2] == 'e')&& (tmp[3] == 'g') && (tmp[4] == 'e')&& (tmp[5] == 'n')) {
    if((tmp[6] == '1') && (tmp[7] == '2')|| (tmp[6] == '2') && (tmp[7] == '1')) {
    xil_printf("\n 1 & 2\r");
    buf[0] = 'q';
    buf[1] = 0;
    return; 
	}
	else if((tmp[6] == '2') && (tmp[7] == '3')|| (tmp[6] == '3') && (tmp[7] == '2')) {
    xil_printf("\n 2 & 3\r");
    buf[0] = 'r';
    buf[1] = 0;
    return; 
	}
	else if((tmp[6] == '3') && (tmp[7] == '1')|| (tmp[6] == '1') && (tmp[7] == '3')) {
    xil_printf("\n 3 &1\r");
	buf[0] = 's';
    buf[1] = 0;
    return; 
	}
    else if((tmp[6] == '1') && (tmp[7] == 'p')|| (tmp[6] == 'p') && (tmp[7] == '1')) {
    xil_printf("\n 1 & p\r");
    buf[0] = 't';
    buf[1] = 0;
    return; 
	}
	else if((tmp[6] == '2') && (tmp[7] == 'p')|| (tmp[6] == 'p') && (tmp[7] == '2')) {
    xil_printf("\n 2 & p\r");
    buf[0] = 'u';
    buf[1] = 0;
    return; 
	}
	else if((tmp[6] == '3') && (tmp[7] == 'p')|| (tmp[6] == 'p') && (tmp[7] == '3')) {
    xil_printf("\n 3 & 3\r");
	buf[0] = 'v';
    buf[1] = 0;
    return; 
	}
    else if((tmp[6] == '1') && (tmp[7] == 'q')|| (tmp[6] == 'q') && (tmp[7] == '1')) {
    xil_printf("\n 1 & q\r");
    buf[0] = 'w';
    buf[1] = 0;
    return; 
	}
	else if((tmp[6] == '2') && (tmp[7] == 'q')|| (tmp[6] == 'q') && (tmp[7] == '2')) {
    xil_printf("\n 2 & q\r");
    buf[0] = 'x';
    buf[1] = 0;
    return; 
	}
	else if((tmp[6] == '3') && (tmp[7] == 'q')|| (tmp[6] == 'q') && (tmp[7] == '3')) {
    xil_printf("\n 3 & q\r");
	buf[0] = 'y';
    buf[1] = 0;
    return; 
	}
	else if((tmp[6] == 'p') && (tmp[7] == 'q')|| (tmp[6] == 'q') && (tmp[7] == 'p')) {
    xil_printf("\n p & q\r");
	buf[0] = '0';
    buf[1] = 0;
    return; 
	}
	else {
xil_printf("\ninvalid regenerate command\r");
xil_printf("\nvalid comman example 2regen23 \r"); 
    buf[0] = 'j';
    buf[1] = 0;
    return;  
	}
  }
  else if((tmp[0] == 'u') && (tmp[1] == 'p') && (tmp[2] == 'd')&& (tmp[3] == 'a') && (tmp[4] == 't')&& (tmp[5] == 'e')) {
    xil_printf("\n update....\r");
    buf[0] = 'z';
    buf[1] = 0;
    return; 
  }
  // otherwise, command is unrecognized
  else {

    buf[0] = 0;
    xil_printf("\n\rUnrecognized Command.\n\r");
    return;

  }

}

void init_mem(){


  unsigned long data_start1 = 0x03020100;
  unsigned long data_start2 = 0x04030201;
  unsigned long data_start3 = 0x05040302;
  unsigned long addr_start1 = 0x00010000;
  unsigned long addr_start2 = 0x00020000;
  unsigned long addr_start3 = 0x00030000;
  unsigned long addr_start5 = 0x00050000;
  unsigned long addr_start6 = 0x00060000;

  xil_printf("\ninitializing data blocks\n\r");
  //load first data block
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 0x40404040;
  addr_start1 = addr_start1 + 256;
  ddr_mpmc_load(addr_start1,data_start1);
  data_start1 = data_start1 + 64;
  addr_start1 = addr_start1 + 256;
 
  xil_printf("\n.\n\r");

  //load second data block
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  ddr_mpmc_load(addr_start2,data_start2);
  data_start2 = data_start2 + 64;
  addr_start2 = addr_start2 + 256;
  
  xil_printf("...\n\r");
  //load third data block
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;
  ddr_mpmc_load(addr_start3,data_start3);
  data_start3 = data_start3 + 64;
  addr_start3 = addr_start3 + 256;

  ddr_mpmc_clear(addr_start5);
  ddr_mpmc_clear(addr_start6);

  xil_printf("\ncomplete\n\r");


}

void read_block(unsigned long addr){

 unsigned long p;
 unsigned long readdata;
xil_printf("\n\r");
for(p = addr;  p < addr + 512 ; p = p+16)
  {
    readdata = ddr_mpmc_read(p); 
    xil_printf("0x%08X",readdata);
	xil_printf(" ");
    readdata = ddr_mpmc_read(p+4);
    xil_printf("0x%08X",readdata);
	xil_printf(" ");
    readdata = ddr_mpmc_read(p+8); 
    xil_printf("0x%08X",readdata);
	xil_printf(" ");
    readdata = ddr_mpmc_read(p+12);
    xil_printf("0x%08X",readdata);
	xil_printf(" ");
	xil_printf("\n\r");
    usleep(10000);
  }

}

void user_write(unsigned long addr, Xuint8 data) {
if(data == 0x30){
    ddr_mpmc_write(addr,0x00000000);
}
else if(data == 0x35){
    ddr_mpmc_write(addr,0x55555555);
}
else if((data == 0x41) ||(data == 0x61)){
    ddr_mpmc_write(addr,0xAAAAAAAA);
}
else {
ddr_mpmc_write(addr,0xFFFFFFFF);

}
}

void print_message(){
    xil_printf("\n\n\n\n\n\n\n\n\n\n\r");
    xil_printf("\n***************************************************************************\r");
	xil_printf("\n*#########################################################################*\r");
    xil_printf("\n*                         Welcome to the RAID6 Demo                       *\r");
    xil_printf("\n***************************************************************************\r");
    xil_printf("\n*                                                                         *\r");
    xil_printf("\n*  Please choose the function you would like to run                       *\r");
    xil_printf("\n*                                                                         *\r");
    xil_printf("\n*                                                                         *\r");
    xil_printf("\n*  to Clear Memory             clr1,2,3,p,q,or a for all                  *\r");
    xil_printf("\n*  to Write a Data block       wr1,2,3 x[0|5|a|f]                         *\r");
    xil_printf("\n*  to Read a Data block        rd1,2,3,p, or q                            *\r");
    xil_printf("\n*  to Generate Parity Blocks   genp or genq                               *\r");
    xil_printf("\n*  to Initialize Data          init                                       *\r");
	xil_printf("\n*  to Regenerate data          regen1,2, or                               *\r");
	xil_printf("\n*  to Create data pattern      cdp1,2,3                                   *\r");
	xil_printf("\n*  to Regenerate 2 disks       2regen(12,23,31,{1p,2p,3p}, {1q,2q,3q})    *\r");
    xil_printf("\n*  to Generate both parity     2regenpq                                   *\r");
	xil_printf("\n*  to Update parity            update (must first update data2(new data)  *\r");
	xil_printf("\n*  to List options             ls                                         *\r");
	xil_printf("\n***************************************************************************\r");
    xil_printf("\n\r");
}

void pattern_write(unsigned long addr, unsigned long data) {

unsigned long data_start = data;
unsigned long addr_start;
  xil_printf("\n\rloading pattern to the memory \r");
  xil_printf("\n.\n");
for(addr_start = addr; addr_start < addr+512; addr_start=addr_start+4)
    {
    ddr_mpmc_write(addr_start,data);
    data=data+0x01000001;
    }

  
  
}

